<?php

/* This layout is loaded only if default theme layouts are used */

remove_filter( 'the_title', 'terraclassifieds_remove_page_title' );
remove_filter( 'the_content', 'terraclassifieds_replace_content' );
remove_filter( 'post_thumbnail_html', 'terraclassifieds_remove_featured_image' );

$price = get_post_meta( get_the_ID(), '_tc_price', true );
$negotiable = get_post_meta( get_the_ID(), '_tc_negotiable', false );
$sell_type = get_post_meta( get_the_ID(), '_tc_sell_type', 'price' );
$currency = terraclassifieds_get_option( '_tc_advert_currency', '$' );
$unit_position = terraclassifieds_get_option( '_tc_unit_position', 1 );
$add_to_favourites = terraclassifieds_get_option( '_tc_ad_view_add_to_favourites', 0 );
$show_location = terraclassifieds_get_option( '_tc_show_location', 1 );
$use_types = terraclassifieds_get_option( '_tc_use_types', 0 );
$email = get_post_meta( get_the_ID(), '_tc_email', true );
$autor_email = get_the_author_meta("user_email");
$autor_id = get_the_author_meta("ID");
$post_id = get_the_ID();
$gallery = get_post_meta( get_the_ID(), '_tc_gallery', true );
$user_id = get_the_author_meta( 'ID' );
$avatar_url = get_user_meta( $user_id, '_tc_avatar', 1 );
?>
		<article <?php post_class(); ?>>

			<div class="terraclassifieds-top">

				<div class="terraclassifieds-content">
					
					<?php terraclassifieds_breadcrumbs(); ?>
					
					<?php if (!empty($gallery)) { ?>
						<div class="terraclassifieds-image">
							<?php if($add_to_favourites){ ?>
								<div class="terraclassifieds-fav">
									<?php
										// retrieve the total love count for this item
										$love_count = li_get_love_count($post_id);
										if(!tcf_user_has_liked_post($user_id, get_the_ID())) {
											echo '<span class="fav-it" data-post-id="' . get_the_ID() . '" data-user-id="' .  esc_attr($user_id) . '">&nbsp;</span>';
										} else {
											echo '<span class="liked" data-post-id="' . get_the_ID() . '" data-user-id="' .  esc_attr($user_id) . '"></span>';
										}
									?>
								</div>
							<?php } ?>
							<?php cmb2_output_file_list_first_image( '_tc_gallery', 'tcf-single' ); ?>
						</div>
					<?php } ?>

					<div class="terraclassifieds-content-in">
						<header class="terraclassifieds-page-header">
							<h1 class="terraclassifieds-main-title"><?php the_title(); ?></h1>
							<?php if($use_types && has_term( '', 'ad_type' )) { ?>
								<span class="terraclassifieds-types">
									<?php
										$terraclassifieds_types = get_the_terms( $post_id, 'ad_type' );
										foreach($terraclassifieds_types as $terraclassifieds_type) {
											echo '<span class="terraclassifieds-type terraclassifieds-type-' . $terraclassifieds_type->slug . '">'.$terraclassifieds_type->name.'</span>';
										}
									?>
								</span>
							<?php } ?>
							<div class="terraclassifieds-publish-time"><span class="terraclassifieds-label"><?php _e('Added','terraclassifieds') ?></span> <?php the_date(); ?></div>
						</header>

						<div class="terraclassifieds-desc">
							<?php the_content(); ?>
						</div>
						<?php // echo gallery ?>
						<?php 
							if(!empty($gallery)){
								if(!empty($gallery)){
									unset($gallery[key($gallery)]); // remove first element from array
								}
								$files_number = count($gallery);
						?>
						<?php if(!empty($gallery)){ ?>
							<div class="lightSliderOuter number-images-<?php echo esc_attr($files_number); ?>">
								<ul id="vertical" class="lightSlider">
										<?php foreach ( $gallery as $key => $value ) {
											$thumb_url = wp_get_attachment_image_src($key,'thumbnail', true);
											$large_url = wp_get_attachment_image_src($key,'tcf-single', true); ?>
												<li data-thumb="<?php echo esc_url($thumb_url[0]); ?>" data-src="<?php echo esc_url($large_url[0]); ?>">
													<?php echo wp_get_attachment_image( $key, 'tcf-single' ); ?>
												</li>
										<?php } ?>
								</ul>
							</div>
						<?php } ?>
						<?php } ?>
					</div>
				</div>
				
				<div class="terraclassifieds-details">

					<?php if( !empty($price) || $sell_type == 'for_free' || $sell_type == 'exchange') { ?>
					<div class="terraclassifieds-price">
						<span class="terraclassifieds-label"><?php _e('Price:', 'terraclassifieds'); ?></span>
						<?php if($sell_type == 'for_free'){ ?>
							<?php echo __( 'For Free', 'terraclassifieds' ); ?>
						<?php } else if($sell_type == 'exchange'){ ?>
							<?php echo __( 'Exchange', 'terraclassifieds' ); ?>
						<?php } else { ?>
							<?php if(!empty($currency) && $unit_position == 0){ ?>
								<?php echo esc_attr($currency); ?>
							<?php } ?>
							<?php echo esc_attr($price); ?>
							<?php if(!empty($currency) && $unit_position == 1){ ?>
								<?php echo esc_attr($currency); ?>
							<?php } ?>
						<?php } ?>
						<?php if(!empty(sizeof($negotiable))){ ?>
							<div class="terraclassifieds-negotiable-price">
								<?php _e('negotiable','terraclassifieds');?>
							</div>
						<?php } ?>
					</div>
					<?php } ?>
					
					<div class="terraclassifieds-contact-form">
						<button class="terraclassifieds-btn terraclassifieds-contact-advertiser"><?php _e('Contact this advertiser', 'terraclassifieds') ?></button>
						<form action="<?php the_permalink(); ?>" id="terraclassifieds-contact-form"  method="post">
							
							<?php if ( !is_user_logged_in() ) { ?>
							<p class="terraclassifieds-form-username">
								<label for="terraclassifieds-username"><?php _e('Your name','terraclassifieds');?></label>
								<input type="text" id="terraclassifieds-username" name="tc_username" class="terraclassifieds-input" />
							</p>

							<p class="terraclassifieds-form-email">
								<label for="terraclassifieds-useremail"><?php _e('Your email','terraclassifieds');?></label>
								<input type="text" id="terraclassifieds-useremail" name="tc_email" class="terraclassifieds-input" />
							</p>
							<?php } ?>

							<p class="terraclassifieds-form-message">
								<label for="terraclassifieds-message"><?php _e('Message','terraclassifieds');?></label>
								<textarea id="terraclassifieds-message" name="tc_message" class="terraclassifieds-input"></textarea>
							</p>
							
							<?php if ( !is_user_logged_in() ) { ?>
								<div class="gdpr-checkboxes">
									<?php require_once(plugin_dir_path(__FILE__) . '../inc/security.php'); ?>
								 </div>
							 <?php } ?>
							 
							<p class="terraclassifieds-form-submit">
								<input type="hidden" name="tc_to" value="<?php echo esc_attr($autor_email); ?>">
								<input type="hidden" name="tc_classified_author_id" value="<?php echo esc_attr($autor_id); ?>">
								<input type="hidden" name="tc_classified_id" value="<?php echo esc_attr($post_id); ?>">
								<input type="hidden" name="tc_form_action" value="1">
								<input type="submit" class="terraclassifieds-btn" name="user-submit" value="<?php _e('Send message','terraclassifieds');?>" />
							</p>

						</form>
					</div>
					
					<?php
						if(!empty(get_the_author_meta("_tc_phone"))){ ?>
							<div class="terraclassifieds-phone">
								<span class="terraclassifieds-label"><?php _e('Phone:', 'terraclassifieds'); ?></span>
								<span class="terraclassifieds-value">
									<?php echo get_the_author_meta("_tc_phone"); ?>
								</span>
								<span class="terraclassifieds-phone-more"><?php _e('show', 'terraclassifieds'); ?></span>
							</div>
						<?php }
					?>

					<?php if( has_term( '', 'ad_location' ) && $show_location) {
						$terraclassifieds_locations = get_the_terms( $post_id, 'ad_location' );
						$terraclassifieds_locations_splitted = join(', ', wp_list_pluck($terraclassifieds_locations, 'name')); ?>
						<div class="terraclassifieds-location">
							<span class="terraclassifieds-label"><?php _e('Location:', 'terraclassifieds'); ?></span>
							<span class="terraclassifieds-value">
								<i class="fa fa-map-marker" aria-hidden="true"></i> <?php echo $terraclassifieds_locations_splitted; ?>
							</span>
						</div>
					<?php } ?>
					
					<?php if(!empty(get_the_author_meta("user_url"))){ ?>
						<div class="terraclassifieds-website">
							<span class="terraclassifieds-label"><?php _e('Website:', 'terraclassifieds'); ?></span> <a href="<?php echo get_the_author_meta("user_url"); ?>" target="_blank"><?php echo get_the_author_meta("user_url"); ?></a>
						</div>
					<?php } ?>

					<div class="terraclassifieds-author">
						<span class="terraclassifieds-label"><?php _e('Created by:', 'terraclassifieds'); ?></span> 
						<div class="terraclassifieds-author-in">
							<div class="terraclassifieds-author-avatar">
								<?php if(!empty($avatar_url)){ ?>
									<img class="terraclassifieds-user-avatar" src="<?php echo esc_url($avatar_url); ?>" alt="user-avatar" />
								<?php } else { ?>
									<img class="terraclassifieds-user-avatar" src="<?php echo plugins_url('assets/img/default-avatar.jpg', dirname(__FILE__)); ?>" alt="user-avatar" />
								<?php } ?>
							</div>
							<a class="terraclassifieds-author-name" href="<?php echo esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ); ?>">
								<?php if((get_the_author_meta( 'user_firstname' )) || (get_the_author_meta( 'user_lastname' ))){ ?>
									<?php _e('See all ads by', 'terraclassifieds'); ?> <?php echo get_the_author_meta( 'user_firstname' ).' '.get_the_author_meta( 'user_lastname' ); ?>
								<?php } else { ?>
									<?php _e('No name', 'terraclassifieds'); ?>
								<?php } ?>
							</a>
						</div>
					</div>
					
					<div class="terraclassifieds-contact-form abuse-form">
						<button class="terraclassifieds-btn terraclassifieds-contact-advertiser"><?php _e('Report abuse', 'terraclassifieds') ?></button>
						<form action="<?php the_permalink(); ?>" id="terraclassifieds-abuse-form"  method="post">
							
							<?php if ( !is_user_logged_in() ) { ?>
							<p class="terraclassifieds-form-username">
								<label for="terraclassifieds-username"><?php _e('Your name','terraclassifieds');?></label>
								<input type="text" id="terraclassifieds-username" name="tc_username_abuse" class="terraclassifieds-input" />
							</p>

							<p class="terraclassifieds-form-email">
								<label for="terraclassifieds-useremail"><?php _e('Your email','terraclassifieds');?></label>
								<input type="text" id="terraclassifieds-useremail" name="tc_email_abuse" class="terraclassifieds-input" />
							</p>
							<?php } ?>

							<p class="terraclassifieds-form-message">
								<label for="terraclassifieds-message"><?php _e('Message','terraclassifieds');?></label>
								<textarea id="terraclassifieds-message" name="tc_message_abuse" class="terraclassifieds-input"></textarea>
							</p>

							<?php if ( !is_user_logged_in() ) { ?>
								<div class="gdpr-checkboxes">
									<?php require_once(plugin_dir_path(__FILE__) . '../inc/security-abuse-form.php'); ?>
								 </div>
							 <?php } ?>
							 
							<p class="terraclassifieds-form-submit">
								<input type="hidden" name="tc_to" value="<?php echo esc_attr($autor_email); ?>">
								<input type="hidden" name="tc_classified_author_id" value="<?php echo esc_attr($autor_id); ?>">
								<input type="hidden" name="tc_classified_id" value="<?php echo esc_attr($post_id); ?>">
								<input type="hidden" name="tc_form_action_abuse" value="1">
								<input type="submit" class="terraclassifieds-btn" name="user-submit" value="<?php _e('Send message','terraclassifieds');?>" />
							</p>

						</form>
					</div>

				</div>
			</div>
		</article>
